<?php
namespace Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Ate12200VooTrechoController extends \Teknisa\GER\Controllers\TeknisaCrud {
	protected $Ate12200VooTrechoService;
	protected $entityManager;
	protected $connection;
	protected $environment;
	protected $messagesProcedureInflightor;
		
	public function __construct($crudService, $parameterBagColumns, $entityManager, $Ate12200VooTrechoService, $connection, $environment, $messagesProcedureInflightor) {
		$this->crudService = $crudService;
		$this->entityManager = $entityManager;
		$this->Ate12200VooTrechoService = $Ate12200VooTrechoService;
		$this->connection = $connection;
        $this->environment = $environment;
		$this->messagesProcedureInflightor = $messagesProcedureInflightor;
	}

	public function checkVooCode($request, $response) {

		try {

			$rows = $request->getRow();

			$nrvoo = $rows['nrvoo'];
			$cdfilial = $rows['cdfilial'];
			$cdcia = $rows['cdcia'];
			$nrorg = $rows['nrorg'];

			$this->Ate12200VooTrechoService->checkVooCode($nrvoo, $cdfilial, $cdcia, $nrorg, $response);

		}catch(Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}

	}

	public function newVoo($request, $response) {
		$dataSet = $request->getDataSet();
		$rows = $dataSet->getRows();
		$rowVigencia = array_shift($rows);
		$rowsTrechos = array_shift($rows);
		$rowVoo = array_shift($rows);
	  	try {
			$connection = $this->entityManager->getConnection();
		  	$connection->beginTransaction();
		  		if(count($rowVoo)){
					$this->Ate12200VooTrechoService->salvaVoo($request, $response, $rowVoo, $this->crudService);
		  		}
				$this->Ate12200VooTrechoService->salvaTrechos($request, $response, $rowsTrechos, $this->crudService);
	    		$columnsReturn = $this->crudService->getColumnsToReturn();
	    		$rowVigencia['CDTRECHO'] = $columnsReturn[0]['CDTRECHO'];
	    		$rowVigencia['NRVOO'] = $columnsReturn[0]['NRVOO'];
	    		$rowVigencia['NRSEQVOOTRECHODATA'] = "";
	    		foreach ($rowVigencia as $key => $value) {
	    			switch ($key) {
					    case "IDVOODOM":
					        $rowVigencia[$key] = $value == '1' ? 'S' : 'N';
					        break;
					    case "IDVOOSEG":
					        $rowVigencia[$key] = $value == '1' ? 'S' : 'N';
					        break;
					    case "IDVOOTER":
					        $rowVigencia[$key] = $value == '1' ? 'S' : 'N';
					        break;
					    case "IDVOOQUA":
					        $rowVigencia[$key] = $value == '1' ? 'S' : 'N';
					        break;
					    case "IDVOOQUI":
					        $rowVigencia[$key] = $value == '1' ? 'S' : 'N';
					        break;
					    case "IDVOOSEX":
					        $rowVigencia[$key] = $value == '1' ? 'S' : 'N';
					        break;
					    case "IDVOOSAB":
					        $rowVigencia[$key] = $value == '1' ? 'S' : 'N';
					        break;
					}
				}
	    		$this->Ate12200VooTrechoService->salvaVigencia($request, $response, $rowVigencia, $this->crudService);
	    		foreach ($rowVigencia as $key => &$value) {
	    			switch ($key) {
					    case "IDVOODOM":
					        $rowVigencia[$key] = $value == 'S' ? "1" : "2";
					        break;
					    case "IDVOOSEG":
					        $rowVigencia[$key] = $value == 'S' ? "1" : "2";
					        break;
					    case "IDVOOTER":
					        $rowVigencia[$key] = $value == 'S' ? "1" : "2";
					        break;
					    case "IDVOOQUA":
					        $rowVigencia[$key] = $value == 'S' ? "1" : "2";
					        break;
					    case "IDVOOQUI":
					        $rowVigencia[$key] = $value == 'S' ? "1" : "2";
					        break;
					    case "IDVOOSEX":
					        $rowVigencia[$key] = $value == 'S' ? "1" : "2";
					        break;
					    case "IDVOOSAB":
					        $rowVigencia[$key] = $value == 'S' ? "1" : "2";
					        break;
					}
				}
	    		$response->addDataSet(new DataSet('novoVoo', array($rowVigencia)));
	    	$connection->commit();
	  	} catch (Exception $e) {
	  		$connection->rollback();
			$response->setError(new Error($e->getMessage(), 500));
	  	}
	}


	public function newVigencia($request, $response) {
		$dataSet = $request->getDataSet();
		$rows = $dataSet->getRows();
		$row = array_shift($rows);
		$flag = true;
	  	try {
	  	// 	if ($row['IDVOODOM'] == 'N' && $row['IDVOOSEG'] == 'N' && $row['IDVOOTER'] == 'N' && $row['IDVOOQUA'] == 'N' && $row['IDVOOQUI'] == 'N' && $row['IDVOOSEX'] == 'N' && $row['IDVOOSAB'] == 'N') {
		// 		$response->setError(new Error("Nenhuma frequência foi selecionada.", 500));
	  	// 		$flag = false;
	  	// 	}
			$connection = $this->entityManager->getConnection();
		  	$connection->beginTransaction();
	  		if($row['CHANGEDATE']) {
				$flag = $this->Ate12200VooTrechoService->validaVigencia($row, $response);
				if(!$row['__is_new'] && $flag)
					$flag = $this->Ate12200VooTrechoService->validaDataDecolagem($row, $response);
	  		}
			if ($flag) {
				$this->Ate12200VooTrechoService->salvaVigencia($request, $response, $row, $this->crudService);
	    		$connection->commit();
	    	}
	  	} catch (Exception $e) {
	  		$connection->rollback();
			$response->setError(new Error($e->getMessage(), 500));
	  	}
	}

	public function delete($request, $response) {
		if ($this->Ate12200VooTrechoService->removerFilhos($request, $response)){
			try {
				$this->dataSourceName = "voo";
				$request = $this->crudService->buildDataSetIfRow($request, $this->dataSourceName);
				$dataSet = $request->getDataSet();
				$dataSet->setDataSourceName($this->dataSourceName);
				$this->crudService->delete($response, $dataSet);
			} catch (\Exception $e) {
				$response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
			}
		}
	}
	
	public function callProcedureImportaExporta(DTO\Request $request, DTO\Response $response){
	    $connection = $this->entityManager->getConnection();
		try{
			$connection->beginTransaction();
			$row = $request->getRow();
	        $row['CDFILIAL'] = $this->environment->getCdFilial();
	        $row['CDOPERADOR'] = $this->environment->getCdOperador();
	        $row['NRORG'] = $this->environment->getNrOrgTrab();
	        if(is_array($row['NRVOO'])){
	        	$row['VOOSDEST'] = '';
	        	foreach ($row['NRVOO'] as &$voo) {
        			$row['VOOSDEST'] = $row['VOOSDEST'].$voo.'_';
	        	}
	        }
	        $retorno =   $this->EXPORTA_VIGENCIA_VOO($row, $response);
            if($retorno) $connection->commit();
		} catch (\Exception $e) {
            $response->setError(new Error($this->messagesProcedureInflightor->convertMessage($e->getMessage()), 500));
            $connection->rollback();
		}
	}
	
	public function COPIA_VIGENCIA_VOO($row, $response){
		$procedure = new StoredProcedure($this->connection, 'COPIA_VIGENCIA_VOO');
        $procedure->addParam(new Param('P_CDFILIAL',           Param::PARAM_INPUT, $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',              Param::PARAM_INPUT, $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOOORI',           Param::PARAM_INPUT, $row['NRVOOORI']));
        $procedure->addParam(new Param('P_CDTRECHOORI',        Param::PARAM_INPUT, $row['CDTRECHO']));
        $procedure->addParam(new Param('P_NRSEQVOOTRECHODATA', Param::PARAM_INPUT, $row['NRSEQVOOTRECHODATA']));
        $procedure->addParam(new Param('P_VOOSDEST',           Param::PARAM_INPUT, $row['VOOSDEST']));
        $procedure->addParam(new Param('P_DTINI',              Param::PARAM_INPUT, $row['DTINIVIGENCIA']));
        $procedure->addParam(new Param('P_DTFIN',              Param::PARAM_INPUT, $row['DTFIMVIGENCIA']));
        $procedure->addParam(new Param('P_CDOPERADOR',         Param::PARAM_INPUT, $row['CDOPERADOR']));
        $procedure->addParam(new Param('P_NRORG',              Param::PARAM_INPUT, $row['NRORG']));
        $procedure->addParam(new Param('P_NRLISTAERROS',       Param::PARAM_OUTPUT, null, null, 20));
        $result = $procedure->execute();
        
        if($result['P_NRLISTAERROS'] != null) {
        	$this->messagesProcedureInflightor->concatErrorMessages($row['CDFILIAL'], $result['P_NRLISTAERROS'], $response);
        	return false;
        } else {
        	return true;
        }
	}
	
	public function EXPORTA_VIGENCIA_VOO($row, $response){
		$procedure = new StoredProcedure($this->connection, 'EXPORTA_VIGENCIA_VOO');
        $procedure->addParam(new Param('P_CDFILIAL',           Param::PARAM_INPUT, $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',              Param::PARAM_INPUT, $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOOORI',           Param::PARAM_INPUT, $row['NRVOOORI']));
        $procedure->addParam(new Param('P_CDTRECHOORI',        Param::PARAM_INPUT, $row['CDTRECHO']));
        $procedure->addParam(new Param('P_NRSEQVOOTRECHODATA', Param::PARAM_INPUT, $row['NRSEQVOOTRECHODATA']));
        $procedure->addParam(new Param('P_VOOSDEST',           Param::PARAM_INPUT, $row['VOOSDEST']));
        $procedure->addParam(new Param('P_CDOPERADOR',         Param::PARAM_INPUT, $row['CDOPERADOR']));
        $procedure->addParam(new Param('P_NRORG',              Param::PARAM_INPUT, $row['NRORG']));
        $procedure->addParam(new Param('P_NRLISTAERROS',       Param::PARAM_OUTPUT, null, null, 20));
        $result = $procedure->execute();
        
        if($result['P_NRLISTAERROS'] != null) {
        	$this->messagesProcedureInflightor->concatErrorMessages($row['CDFILIAL'], $result['P_NRLISTAERROS'], $response);
        	return false;
        } else {
        	return true;
        }
	}
}